function EventBase(eventId, method, serviceName, requestType, ScreenService) {
	var self = this;
	this.args = null;
	this.id = eventId;
	this.method = method;
	this.serviceName = serviceName;
	this.requestType = requestType;
	this.getServiceName = function() {
		return this.serviceName;
	};

	this.getTypeRequest = function() {
		return this.requestType;
	};

	//This auxiliary function is used within the for cycle, in line 164.
	function aux1(item) {
		return '"' + item + '"';
	}

	this.getRequestCallback = function() {
		return function(response, args) {
			for (var i in response.method) {
				if (response.method.hasOwnProperty(i)) {
					var method = response.method[i];
					var params = method.parameters.map(aux1).join(',');
					params += params ? ", args" : "args";
					/*jslint evil: true */
					eval(method.name + "(" + params + ");");
				}
			}
			for (i in response.messages) {
				if (response.messages.hasOwnProperty(i)) {
					var message = response.messages[i];
					ScreenService.showMessage(message.message, message.type);
				}
			}
			if (response.notifications) {
				response.notifications.forEach(function(notification) {
					ScreenService.notificationMessage(notification.message, notification.type);
				});
			}
		};
	};
	this.getId = function() {
		return this.id;
	};
	this.request = function(restEngine, eventHandler, requestFactory, args) {
		this.args = args;
		var callback = function(response) {
			self.getRequestCallback()(response, args);
			return eventHandler.notifyEnd(self);
		};

		var request = requestFactory.factory({
			"serviceName": self.serviceName,
			"row": args.row,
			'requestType': self.requestType,
			"callBack": self.getRequestCallback(),
			"dataSource": args.dataSource
		});
		restEngine.request(
			request.getServiceName(),
			request.getRequestParams(),
			callback
		);
	};
}